local kitchenKidsUtils = {}
local kitchenKidsUtilsPersistency = persistency:getPackagePersistency("kitchenKidsUtils")



------------------------------------------------------------------------------
-------------------- kitchen scripts --------------------------------------
------------------------------------------------------------------------------

kitchenTrashItemsPositions = {{{x=38, y=23}, {x=77, y=50}, {x=32, y=50}, {x=52, y=21},
                            {x=25.5, y=20},{x=54, y=48},{x=82, y=22},{x=91, y=78.5}},

                            {{x=32, y=49.5}, {x=45, y=23}, {x=60, y=50}, {x=22, y=21.5},
                            {x=77.5, y=49.5},{x=88.5, y=22},{x=65, y=22},{x=49, y=49.5}},

                            {{x=87, y=24}, {x=90, y=75.5}, {x=72, y=50.5}, {x=34, y=49},
                            {x=67, y=21},{x=25, y=22.5},{x=55.5, y=48},{x=39, y=22}}}


--- get the X position of th item from the coresponding array
-- @function kitchenKidsUtils.getKitchenItemsXPos
-- @param arrayId
-- @param itemId
kitchenKidsUtils.getKitchenItemsXPos = function(arrayId,itemId)
    return kitchenTrashItemsPositions[arrayId][itemId].x
end

--- get the Y position of th item from the coresponding array
-- @function kitchenKidsUtils.getKitchenItemsYPos
-- @param arrayId
-- @param itemId
kitchenKidsUtils.getKitchenItemsYPos = function(arrayId,itemId)
    return kitchenTrashItemsPositions[arrayId][itemId].y
end


towelStainsPositions = {{{x=24, y=40}, {x=41, y=65}, {x=71, y=38}, {x=89, y=65}},

                        {{x=21, y=63.5}, {x=16, y=85}, {x=70, y=85}, {x=60, y=38}},

                        {{x=88.5, y=55},{x=34, y=89},{x=22, y=37},{x=71, y=86.5}}}

--- get the X position of th item from the coresponding array
-- @function kitchenKidsUtils.getKitchenStainPosX
-- @param arrayId
-- @param itemId
kitchenKidsUtils.getKitchenStainPosX = function(arrayId,itemId)
    return towelStainsPositions[arrayId][itemId].x
end

--- get the Y position of th item from the coresponding array
-- @function kitchenKidsUtils.getKitchenStainPosY
-- @param arrayId
-- @param itemId
kitchenKidsUtils.getKitchenStainPosY = function(arrayId,itemId)
    return towelStainsPositions[arrayId][itemId].y
end
--- increase the paramethar
-- @function kitchenKidsUtils.increaseItem_value
-- @param itemId
-- @param val
-- @param pos
kitchenKidsUtils.increaseItem_value = function(itemId,val,pos)
    local itemValue = 0
    if(pos == 'x')then
        itemValue = TTP_Utils.kitchenKidsUtils.getKitchenStainPosX(kitchenStainsSet,itemId)
    else
        itemValue = TTP_Utils.kitchenKidsUtils.getKitchenStainPosY(kitchenStainsSet,itemId)
    end
    return itemValue + val
end
------------------------------------------------------------------------------
-------------------- icecream scene  --------------------------------------
------------------------------------------------------------------------------
iceCreamKidsArray = {}

--- create the fruit array with the parameter of how many fruits we will have in the scene
-- @function kitchenKidsUtils.createFruitsArray
-- @param num
kitchenKidsUtils.createIcecreamKidsArray = function(num)

    for i=1, num do
        itemsTempArray = {}
        itemsTempArray.name = "kid_"..i
        itemsTempArray.id = i

        table.insert (iceCreamKidsArray, itemsTempArray)
    end
end
--- get random parent
-- @function kitchenKidsUtils.getRandomKid
kitchenKidsUtils.getRandomKid = function()
    local ranomizedKid = math.random (1, 100)
    local kidId = 1

    ranomizedKid = math.random(1,#iceCreamKidsArray)
    kidId = iceCreamKidsArray[ranomizedKid].id
    table.remove(iceCreamKidsArray, ranomizedKid)

    return kidId
end

--- clear the items  array
-- @function kitchenKidsUtils.clearKidsList
kitchenKidsUtils.clearKidsList = function()
    for k,v in pairs(iceCreamKidsArray) do
        iceCreamKidsArray[k] = nil
    end
end

fruits_ItemsList = {}

--- create the fruit array with the parameter of how many fruits we will have in the scene
-- @function kitchenKidsUtils.createFruitsArray
-- @param num
kitchenKidsUtils.createFruitsArray = function(num)

    for i=1, num do
        itemsTempArray = {}
        itemsTempArray.name = "fruit_"..i
        itemsTempArray.id = i

        table.insert (fruits_ItemsList, itemsTempArray)
    end
end

--- clear the items  array
-- @function kitchenKidsUtils.clearFruitList
kitchenKidsUtils.clearFruitList = function()
    for k,v in pairs(fruits_ItemsList) do
        fruits_ItemsList[k] = nil
    end
end
------------------------------------------------------------------------------
------------------- randomize ice cream fruits ---------------------------
------------------------------------------------------------------------------

--- create random product list
-- @function kitchenKidsUtils.createRandomFruitList
-- @param val
kitchenKidsUtils.createRandomFruitList = function(val)
    local ranomizedFruit = math.random (1, 100)
    local fruitId = 0

    for i=1, val do
        ranomizedFruit = math.random(1,#fruits_ItemsList)
        local fruitId = fruits_ItemsList[ranomizedFruit].id
        _G["iceCreamFruit_"..i] = fruitId
        table.remove(fruits_ItemsList, ranomizedFruit)
    end

end

------------------------------------------------------------------------------
-------------------- random free scenes --------------------------------------
------------------------------------------------------------------------------
freeScenesList = {}

-- @function kitchenKidsUtils.initilazeScene
-- @param id
-- @param name
-- @param lock
kitchenKidsUtils.initilazeScene = function(id,name,lock)
    local itemsTempArray = {}
    itemsTempArray.id = id
    itemsTempArray.name = name
    itemsTempArray.isLock = lock
    itemsTempArray.isAvailable = true

    table.insert (freeScenesList, itemsTempArray)

end
--- get random freeScene
-- @function kitchenKidsUtils.getRandomFreeScene
-- @param pos
kitchenKidsUtils.getRandomFreeScene = function()
    local randomIndex = math.random(1,100)
    local randomId = 0
    local freeScenes = {}

    for k,v in pairs(freeScenesList)do
        if ((not(v.isLock)) and (v.isAvailable))then
            table.insert (freeScenes, freeScenesList[k])
        end
    end

    randomIndex = math.random(1,#freeScenes)
    randomId = freeScenes[randomIndex].id
    freeScenes[randomIndex].isAvailable = false

    return randomId
end

--- get random Scene
-- @function kitchenKidsUtils.getRandomUnlockFile
-- @param pos
kitchenKidsUtils.getRandomScene = function()
    local randomIndex = math.random(1,100)
    local randomId = 0
    local availableScenes = {}

    for k,v in pairs(freeScenesList)do
        if (v.isAvailable)then
            table.insert (availableScenes, freeScenesList[k])
        end
    end

    randomIndex = math.random(1,#availableScenes)
    randomId = availableScenes[randomIndex].id
    availableScenes[randomIndex].isAvailable = false

    return randomId
end

--- get scene name
-- @function kitchenKidsUtils.getSceneName
-- @param id
kitchenKidsUtils.getSceneName = function(id)
    for k,v in pairs(freeScenesList)do
        if(v.id == id)then
            return v.name
        end
    end
    return false
end
--- get scene name
-- @function kitchenKidsUtils.changeSceneAvailable
-- @param id
kitchenKidsUtils.changeSceneAvailable = function(name)
    for k,v in pairs(freeScenesList)do
        if(v.name == name)then
            v.isAvailable = false
        end
    end
    return false
end

--- clear the items  array
-- @function kitchenKidsUtils.clearFreeScenesList
kitchenKidsUtils.clearFreeScenesList = function()
    for k,v in pairs(freeScenesList) do
        freeScenesList[k] = nil
    end
end

------------------------------------------------------------------------------
--------------------  create and initilize the products list --------------------
------------------------------------------------------------------------------

products_ItemsList = {}


--- create the products array with the parameter of how many products we will have in the scene
-- @function kitchenKidsUtils.createProductsArray
-- @param num
kitchenKidsUtils.createProductsArray = function(num)

    for i=1, num do
        itemsTempArray = {}
        itemsTempArray.name = "product_"..i
        itemsTempArray.id = i

        table.insert (products_ItemsList, itemsTempArray)
    end
end

--- clear the items  array
-- @function kitchenKidsUtils.clearProductsList
kitchenKidsUtils.clearProductsList = function()
    for k,v in pairs(products_ItemsList) do
        products_ItemsList[k] = nil
    end
end

------------------------------------------------------------------------------
------------------- randomize supermarket products ---------------------------
------------------------------------------------------------------------------

supermarketProductsFirstArray = {}
supermarketProductsSecondArray = {}
supermarketProductsFinalArray = {}
supermarketGroceriesArray = {}
randomProductsGiven = 0

--- create random product list
-- @function kitchenKidsUtils.createRandomProductList
-- @param val
kitchenKidsUtils.createRandomProductList = function(val)
    local ranomizedProduct = math.random (1, 100)
    local givenRandomProducts = 0
    local lenthOfFirstProductsArray = 12
    for i=1, val do
        if(4 > givenRandomProducts)then
            givenRandomProducts = givenRandomProducts + 1
            ranomizedProduct = math.random(1,lenthOfFirstProductsArray)
            local productId = products_ItemsList[ranomizedProduct].id
            table.insert (supermarketProductsFirstArray, productId)
            table.insert (supermarketProductsFinalArray, productId)
            table.insert (supermarketGroceriesArray, productId)
            table.remove(products_ItemsList, ranomizedProduct)
            lenthOfFirstProductsArray = 12 - givenRandomProducts
        else
            givenRandomProducts = givenRandomProducts + 1
            ranomizedProduct = math.random(13,#products_ItemsList)
            local productId = products_ItemsList[ranomizedProduct].id
            table.insert (supermarketProductsSecondArray, productId)
            table.insert (supermarketProductsFinalArray, productId)
            table.insert (supermarketGroceriesArray, productId)
            table.remove(products_ItemsList, ranomizedProduct)
        end
        
    end
end
--- create the products array with the parameter of how many products we will have in the scene
-- @function kitchenKidsUtils.createProductsArray
-- @param num
kitchenKidsUtils.getProductsId = function(num)
    local ranomizedProduct = math.random (1, 100)
    local productId = 1

    for i=1, num do
        if(4 > randomProductsGiven)then
            randomProductsGiven = randomProductsGiven + 1
            ranomizedProduct = math.random(1,#supermarketProductsFirstArray)
            productId = supermarketProductsFirstArray[ranomizedProduct]
            _G["productList"..i] = productId
            table.remove(supermarketProductsFirstArray, ranomizedProduct)
        else
            randomProductsGiven = randomProductsGiven + 1
            ranomizedProduct = math.random(1,#supermarketProductsSecondArray)
            productId = supermarketProductsSecondArray[ranomizedProduct]
            _G["productList"..i] = productId
            table.remove(supermarketProductsSecondArray, ranomizedProduct)
        end
    end
end

--- get random final product id
-- @function kitchenKidsUtils.getRandomFinalProductId
-- @param pos
kitchenKidsUtils.getRandomFinalProductId = function()
    local ranomizedProduct = math.random (1, 100)
    local productId = 1

    ranomizedProduct = math.random(1,#supermarketProductsFinalArray)
    productId = supermarketProductsFinalArray[ranomizedProduct]
    table.remove(supermarketProductsFinalArray, ranomizedProduct)

    return productId
end
--- get random grocerie product id
-- @function kitchenKidsUtils.getRandomGroceriesProductId
-- @param pos
kitchenKidsUtils.getRandomGroceriesProductId = function()
    local ranomizedProduct = math.random (1, 100)
    local productId = 1

    ranomizedProduct = math.random(1,#supermarketGroceriesArray)
    productId = supermarketGroceriesArray[ranomizedProduct]
    table.remove(supermarketGroceriesArray, ranomizedProduct)

    return productId
end

local function checkProductHeld (productID)
    local _tempBool
    if (supermarketProductId == productID) then
        _tempBool = true
    else
        _tempBool = false
    end
    return _tempBool
end

--- check ig that is the valid product
-- @function kitchenKidsUtils.checkValidProduct
kitchenKidsUtils.checkValidProduct = function(productID)
    local _isProductHeld = checkProductHeld(productID)
    if _isProductHeld then
        for i=1, #supermarketProductsFinalArray do
            if (supermarketProductsFinalArray[i] == supermarketProductId) then
                return true
            end
        end
    else
        return false
    end
end

--- check ig that is the unvalid product
-- @function kitchenKidsUtils.checkValidProduct
kitchenKidsUtils.checkUnValidProduct = function(productID)
    local _isProductHeld = checkProductHeld(productID)
    if _isProductHeld then
        for i=1, #supermarketProductsFinalArray do
            if (supermarketProductsFinalArray[i] == supermarketProductId) then
                return false
            end
        end
        return true
    else
        return true
    end
end

--- clear supermarket products list
-- @function kitchenKidsUtils.clearSupermarketProductList
kitchenKidsUtils.clearSupermarketProductList = function()

    for k,v in pairs(supermarketProductsFirstArray) do
        supermarketProductsFirstArray[k] = nil
    end
    for k,v in pairs(supermarketProductsSecondArray) do
        supermarketProductsSecondArray[k] = nil
    end
    for k,v in pairs(supermarketProductsFinalArray) do
        supermarketProductsFinalArray[k] = nil
    end
    for k,v in pairs(supermarketGroceriesArray) do
        supermarketGroceriesArray[k] = nil
    end
end

------------------------------------------------------------------------------
-------------------- randomize doctor tools ----------------------------------
------------------------------------------------------------------------------
doctorTools_List = {}
doctorTools_ItemsList = {}

--- create the doctor tools array with the parameter of how many tools we will have in the scene
-- @function kitchenKidsUtils.createToolsArray
-- @param num
kitchenKidsUtils.createToolsArray = function(num)
    local ranomizedTool = math.random (1, 100)
    local toolId = 1

    for i=1, num do
        itemsTempArray = {}
        itemsTempArray.name = "doctorTool_"..i
        itemsTempArray.id = i

        table.insert (doctorTools_List, itemsTempArray)
        table.insert (doctorTools_ItemsList, itemsTempArray)
    end

    for i=1, num do
        ranomizedTool = math.random(1,#doctorTools_List)
        toolId = doctorTools_List[ranomizedTool].id
        _G["doctorTool_"..i] = toolId
        table.remove(doctorTools_List, ranomizedTool)
    end
end

local doctorToolPositionY = {77, 59.5, 42, 24.5}
local doctorToolPosition = {}
local doctorRandomizedTools_List = {}

--- get random tool
-- @function kitchenKidsUtils.changeToolsPositions
-- @param val
kitchenKidsUtils.checkToolsPosition = function()
    local _temp3, _temp7

    for i=1, #doctorRandomizedTools_List do

        if(doctorTool_3 == doctorRandomizedTools_List[i])then
            _temp3 = doctorRandomizedTools_List[1]
            doctorRandomizedTools_List[1] = doctorTool_3
            doctorRandomizedTools_List[i] = _temp3
        end
        if(doctorTool_7 == doctorRandomizedTools_List[i])then
            _temp7 = doctorRandomizedTools_List[4]
            doctorRandomizedTools_List[4] = doctorTool_7
            doctorRandomizedTools_List[i] = _temp7
        end
    end
    for i=1, #doctorRandomizedTools_List do

        if(doctorTool_3 == doctorRandomizedTools_List[i])then
            _temp3 = doctorRandomizedTools_List[1]
            doctorRandomizedTools_List[1] = doctorTool_3
            doctorRandomizedTools_List[i] = _temp3
        end
        if(doctorTool_7 == doctorRandomizedTools_List[i])then
            _temp7 = doctorRandomizedTools_List[4]
            doctorRandomizedTools_List[4] = doctorTool_7
            doctorRandomizedTools_List[i] = _temp7
        end
    end

end

--- get random tool
-- @function kitchenKidsUtils.getRandomDoctorTool
-- @param val
kitchenKidsUtils.setToolsPosition = function()
    local tempPos

    for i=1, #doctorRandomizedTools_List do
        tempPos = doctorRandomizedTools_List[i]
        doctorToolPosition[tempPos] = doctorToolPositionY[i]
        services:sendNotification("readyInteractiveTool_"..tempPos)
    end
end
--- get random tool
-- @function kitchenKidsUtils.getRandomDoctorTool
-- @param val
kitchenKidsUtils.getRandomDoctorTool = function(val)
    local ranomizedTool = math.random (1, 100)
    local toolId = 1

    for i=1, val do
        if(val > givenRandomTools)then
            givenRandomTools = givenRandomTools + 1
            ranomizedTool = math.random(1,#doctorTools_ItemsList)
            toolId = doctorTools_ItemsList[ranomizedTool].id
            table.insert (doctorRandomizedTools_List, toolId)
            table.remove(doctorTools_ItemsList, ranomizedTool)
        end
    end
end

--- get tool y pos
-- @function kitchenKidsUtils.getToolYPos
-- @param val
kitchenKidsUtils.getToolYPos = function(toolId)
    return doctorToolPosition[toolId]
end


--- clear the items  array
-- @function kitchenKidsUtils.clearDoctorToolsList
kitchenKidsUtils.clearDoctorToolsList = function()
    for k,v in pairs(doctorTools_List) do
        doctorTools_List[k] = nil
    end
    for k,v in pairs(doctorTools_ItemsList) do
        doctorTools_ItemsList[k] = nil
    end
end
--- clear the items  array
-- @function kitchenKidsUtils.clearDoctorToolsList
kitchenKidsUtils.clearDoctorPositionsList = function()
    for k,v in pairs(doctorRandomizedTools_List) do
        doctorRandomizedTools_List[k] = nil
    end
    for k,v in pairs(doctorToolPosition) do
        doctorToolPosition[k] = nil
    end
end


------------------------------------------------------------------
--------------------- flurry --------------------------------
------------------------------------------------------------------

--- count how many scenes overall did the user enter
-- @function kitchenKidsUtils.setOveralSceneCounter
kitchenKidsUtils.setOveralSceneCounter = function()
    if (overalScenesEntry == 0) then
        overalScenesEntry = 1
    else
        overalScenesEntry = overalScenesEntry + 1
    end
end

--- count how many scenes overall did the user enter
-- @function kitchenKidsUtils.getFlurryByBubbleKitchen
kitchenKidsUtils.getFlurryByBubbleKitchen = function()
    if(nextBtnSession ~= 1)then
        if (kitchenBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","specific_scene_entries_count",pastaSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(kitchenBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","specific_scene_entries_count",cupcakeSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(kitchenBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","specific_scene_entries_count",slicingSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(kitchenBubbleTouchedVar == 4) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(kitchenBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        elseif(kitchenBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Locked")
            end
        end
    else
        if (kitchenBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(kitchenBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(kitchenBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(kitchenBubbleTouchedVar == 4) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(kitchenBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        elseif(kitchenBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Locked")
            end
        end
    end
end
--- count how many scenes overall did the user enter
-- @function kitchenKidsUtils.getFlurryByBubbleDoctor
kitchenKidsUtils.getFlurryByBubbleDoctor = function()
    if(nextBtnSession ~= 1)then
        if (doctorBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","specific_scene_entries_count",pastaSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(doctorBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","specific_scene_entries_count",cupcakeSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(doctorBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","specific_scene_entries_count",slicingSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(doctorBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","specific_scene_entries_count",kitchenDUSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(doctorBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(doctorBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        end
    else
        if (doctorBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(doctorBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(doctorBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(doctorBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(doctorBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(doctorBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        end
    end
end
--- count how many scenes overall did the user enter
-- @function kitchenKidsUtils.getFlurryByBubbleDoctor
kitchenKidsUtils.getFlurryByBubbleSupermarket = function()
    if(nextBtnSession ~= 1)then
        if (supermarketBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","specific_scene_entries_count",pastaSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(supermarketBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","specific_scene_entries_count",cupcakeSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(supermarketBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","specific_scene_entries_count",kitchenDUSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(supermarketBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","specific_scene_entries_count",slicingSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(supermarketBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(supermarketBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        end
    else
        if (supermarketBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(supermarketBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(supermarketBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(supermarketBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(supermarketBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(supermarketBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        end
    end
end
--- count how many scenes overall did the user enter
-- @function kitchenKidsUtils.getFlurryByBubbleDoctor
kitchenKidsUtils.getFlurryByBubbleMakers = function()
    if(nextBtnSession ~= 1)then
        if (eatingBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pasta_Unlocked","specific_scene_entries_count",pastaSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(eatingBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Cupcake_Unlocked","specific_scene_entries_count",cupcakeSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(eatingBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Slicing_Unlocked","specific_scene_entries_count",slicingSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(eatingBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","overall_scene_entries_count",overalScenesEntry)
            analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_KitchenDU_Unlocked","specific_scene_entries_count",kitchenDUSceneEntry)
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(eatingBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Unlocked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Pizza_Locked","specific_scene_entries_count",pizzaSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(eatingBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Unlocked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_IceCream_Locked","specific_scene_entries_count",iceCreamSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        elseif(eatingBubbleTouchedVar == 7) then
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Unlocked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Doctor_Locked","specific_scene_entries_count",doctorSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Unlocked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Unlocked")
            else
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","overall_scene_entries_count",overalScenesEntry)
                analytics:logEventWithParam(false, "FirstSession_Entry_via_Bubble_Supermarket_Locked","specific_scene_entries_count",supermarketSceneEntry)
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Locked")
            end
        end
    else
        if (eatingBubbleTouchedVar == 1) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pasta_Unlocked")
        elseif(eatingBubbleTouchedVar == 2) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Cupcake_Unlocked")
        elseif(eatingBubbleTouchedVar == 3) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Slicing_Unlocked")
        elseif(eatingBubbleTouchedVar == 4) then
            analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","KitchenDU_Unlocked")
        elseif(eatingBubbleTouchedVar == 5) then
            if (inAppProductFullVersion == 1 or inAppProduct_pizza == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Pizza_Locked")
            end
        elseif(eatingBubbleTouchedVar == 6) then
            if (inAppProductFullVersion == 1 or inAppProduct_icecream == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","IceCream_Locked")
            end
        elseif(eatingBubbleTouchedVar == 7) then
            if (inAppProductFullVersion == 1 or inAppProduct_doctor == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Doctor_Locked")
            end
        else
            if (inAppProductFullVersion == 1 or inAppProduct_supermarket == 1) then
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Unlocked")
            else
                analytics:logEventWithParam(false, "Scene_Entry_via_Other_Scene","Entry_via_Other_Scene","Supermarket_Locked")
            end
        end
    end
end

------------------------------------------------------------------
--------------------- persistency --------------------------------
------------------------------------------------------------------
kitchenKidsUtils.setValueToPersistency = function(varName, varValue)
    kitchenKidsUtilsPersistency:setValue(varName, varValue)
end
kitchenKidsUtils.getValueFromPersistency = function(varName)
    local tempVal = kitchenKidsUtilsPersistency:getValue(varName)
    return tonumber(tempVal)
end

kitchenKidsUtils.incrementDataValue = function(varName)
    local tempValue = kitchenKidsUtils.getValueFromPersistency(varName)
    if (tempValue == nil)then
        kitchenKidsUtils.setValueToPersistency(varName, 1)
    else
        tempValue = tempValue + 1
        kitchenKidsUtils.setValueToPersistency(varName, tempValue)
    end
end

app = {}

srvc = {}

srvc.isAndroid = function()

    print("srvc.isAndroid "..tostring(isAndroid).."")

    return (isAndroid == 1)

end


----------------------------------------------------------------------------------------------------------------------------
------------------------ exportScripts -------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------

if not TTP_Utils then TTP_Utils = {} end
if not TTP_Utils.kitchenKidsUtils then TTP_Utils.kitchenKidsUtils = {} end
if not TTP_Utils.srvc then TTP_Utils.srvc = {} end

TTP_Utils.kitchenKidsUtils.getKitchenItemsXPos = kitchenKidsUtils.getKitchenItemsXPos
TTP_Utils.kitchenKidsUtils.getKitchenItemsYPos = kitchenKidsUtils.getKitchenItemsYPos
TTP_Utils.kitchenKidsUtils.getKitchenStainPosX = kitchenKidsUtils.getKitchenStainPosX
TTP_Utils.kitchenKidsUtils.getKitchenStainPosY = kitchenKidsUtils.getKitchenStainPosY
TTP_Utils.kitchenKidsUtils.increaseItem_value = kitchenKidsUtils.increaseItem_value

TTP_Utils.kitchenKidsUtils.initilazeScene = kitchenKidsUtils.initilazeScene
TTP_Utils.kitchenKidsUtils.getRandomFreeScene = kitchenKidsUtils.getRandomFreeScene
TTP_Utils.kitchenKidsUtils.getRandomScene = kitchenKidsUtils.getRandomScene
TTP_Utils.kitchenKidsUtils.clearFreeScenesList = kitchenKidsUtils.clearFreeScenesList
TTP_Utils.kitchenKidsUtils.getSceneName = kitchenKidsUtils.getSceneName
TTP_Utils.kitchenKidsUtils.changeSceneAvailable = kitchenKidsUtils.changeSceneAvailable

TTP_Utils.kitchenKidsUtils.createProductsArray = kitchenKidsUtils.createProductsArray
TTP_Utils.kitchenKidsUtils.clearProductsList = kitchenKidsUtils.clearProductsList
TTP_Utils.kitchenKidsUtils.createRandomProductList = kitchenKidsUtils.createRandomProductList
TTP_Utils.kitchenKidsUtils.getProductsId = kitchenKidsUtils.getProductsId
TTP_Utils.kitchenKidsUtils.getRandomProductId = kitchenKidsUtils.getRandomProductId
TTP_Utils.kitchenKidsUtils.getRandomFinalProductId = kitchenKidsUtils.getRandomFinalProductId
TTP_Utils.kitchenKidsUtils.getRandomGroceriesProductId = kitchenKidsUtils.getRandomGroceriesProductId
TTP_Utils.kitchenKidsUtils.checkValidProduct = kitchenKidsUtils.checkValidProduct
TTP_Utils.kitchenKidsUtils.checkUnValidProduct = kitchenKidsUtils.checkUnValidProduct
TTP_Utils.kitchenKidsUtils.clearSupermarketProductList = kitchenKidsUtils.clearSupermarketProductList

TTP_Utils.kitchenKidsUtils.createToolsArray = kitchenKidsUtils.createToolsArray
TTP_Utils.kitchenKidsUtils.checkToolsPosition = kitchenKidsUtils.checkToolsPosition
TTP_Utils.kitchenKidsUtils.setToolsPosition = kitchenKidsUtils.setToolsPosition
TTP_Utils.kitchenKidsUtils.getRandomDoctorTool = kitchenKidsUtils.getRandomDoctorTool
TTP_Utils.kitchenKidsUtils.getToolYPos = kitchenKidsUtils.getToolYPos
TTP_Utils.kitchenKidsUtils.clearDoctorToolsList = kitchenKidsUtils.clearDoctorToolsList
TTP_Utils.kitchenKidsUtils.clearDoctorPositionsList = kitchenKidsUtils.clearDoctorPositionsList

TTP_Utils.kitchenKidsUtils.createIcecreamKidsArray = kitchenKidsUtils.createIcecreamKidsArray
TTP_Utils.kitchenKidsUtils.getRandomKid = kitchenKidsUtils.getRandomKid
TTP_Utils.kitchenKidsUtils.clearKidsList = kitchenKidsUtils.clearKidsList
TTP_Utils.kitchenKidsUtils.createFruitsArray = kitchenKidsUtils.createFruitsArray
TTP_Utils.kitchenKidsUtils.clearFruitList = kitchenKidsUtils.clearFruitList
TTP_Utils.kitchenKidsUtils.createRandomFruitList = kitchenKidsUtils.createRandomFruitList

TTP_Utils.kitchenKidsUtils.setOveralSceneCounter = kitchenKidsUtils.setOveralSceneCounter
TTP_Utils.kitchenKidsUtils.getFlurryByBubbleKitchen = kitchenKidsUtils.getFlurryByBubbleKitchen
TTP_Utils.kitchenKidsUtils.getFlurryByBubbleDoctor = kitchenKidsUtils.getFlurryByBubbleDoctor
TTP_Utils.kitchenKidsUtils.getFlurryByBubbleSupermarket = kitchenKidsUtils.getFlurryByBubbleSupermarket
TTP_Utils.kitchenKidsUtils.getFlurryByBubbleMakers = kitchenKidsUtils.getFlurryByBubbleMakers
TTP_Utils.kitchenKidsUtils.getFlurryCupcakeTemp = kitchenKidsUtils.getFlurryCupcakeTemp

TTP_Utils.kitchenKidsUtils.setValueToPersistency = kitchenKidsUtils.setValueToPersistency
TTP_Utils.kitchenKidsUtils.getValueFromPersistency = kitchenKidsUtils.getValueFromPersistency
TTP_Utils.kitchenKidsUtils.incrementDataValue = kitchenKidsUtils.incrementDataValue


TTP_Utils.srvc.isAndroid = srvc.isAndroid