--
-- Created by: shalmuy at 10/22/15 Time: 11:01 AM
--


-- export to Utils
if not TTP_Utils then TTP_Utils = {} end

--- TODO: not sure if we want to have this function here
--- this function allows you to bind the function with parameters to a parameterless wrapper function.
--- for example if you have a function hello(num), you can do this:
--- local hello42 = TTP_Utils.bind(hello, 42)
--- and every time you run "hello42()", it will run it as if "hello(42)"
TTP_Utils.bind = function(bindedFunction, ...)
    return function() bindedFunction(unpack(arg))  end
end

--- the problem of unprotected mode is that if your function contains some errors, the Simulator may just crash without reporting the error. To prevent it, bind your function with "safeBind", which guarantees that all errors will be sent to console.
TTP_Utils.safeBind = function(bindedFunction, ...)
    return function()
        local passed, err=pcall(TTP_Utils.bind(bindedFunction, unpack(arg)))
        if not passed then
            error(err)
        end
    end
end






